/*
 ============================================================================
 Name        : fork.c
 Author      : nome
 Version     :
 Copyright   : sistemi operativi
 Description : Hello World in C, Ansi-style
 ============================================================================
 */

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/timeb.h>
#include <sys/time.h>
#include <sys/resource.h>
#include <unistd.h>

void StampaI();

int g_i;

int main(int argc, char **argv) {
	pid_t pid;
	int status = 99;
	struct timeb TStart, TStop;
	struct rusage RStop;

	if (argc < 2) {
		fprintf(stderr, "Errore nei parametri\n");
		fprintf(stderr, "Usage: %s path1 [path2 ...]\n", argv[0]);
		exit(-1);
	}
	g_i = 10;
	StampaI();

	ftime( &TStart);

	pid = fork();

	if (pid < 0)
	{
		fprintf(stderr, "generazione nuovo processo fallita\n");
		exit(-1);
	}
	else if (pid == 0) { 	/* processo figlio */
		printf("Processo figlio (Parent PID=%d, PID=%d)\n",
				getppid(), getpid());
		usleep(1500000);
		g_i = 100;
		StampaI();
		argv[0] = "ls";
		execvp("/bin/ls", argv);
		exit(129);
	}

	printf("Processo padre (Parent PID=%d, PID=%d) in attesa della terminazione del figlio\n",
			getppid(), getpid());
	StampaI();

	wait(&status);
	printf("Esecuzione terminata (pid=%d)\n", pid);
	StampaI();
	status = status >> 8;
	printf("status = %d\n", status);
	ftime( &TStop);
	getrusage( RUSAGE_CHILDREN, &RStop);

	if (TStop.millitm < TStart.millitm) {
		TStop.millitm += 1000;
		TStop.time -= 1;
	}

	printf("Total Elapsed Time: %d.03%d\n", TStop.time - TStart.time, TStop.millitm -TStart.millitm);
	printf("Total Sys Time    : %d.03%d\n", RStop.ru_stime.tv_sec/1000, RStop.ru_stime.tv_usec/1000);
	printf("Total User Time   : %d.03%d\n", RStop.ru_utime.tv_sec/1000, RStop.ru_utime.tv_usec/1000);
	exit(status);
}

void StampaI() {
	static int n = 0;
	printf("(%d) -> g_i = %d\n", ++n, g_i);
}
